local _, core = ...;
core.APCData = {};

local APCData = core.APCData;

function APCData:Print(...)
    local hex = select(4, core.Config:GetThemeColor());
    local prefix = string.format("|cff%s%s|r", hex:upper(), "APCalculator:");
    DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, ...));
end


function APCData:APCalculate(bracket,rating)
	if(rating == nil or rating == 0 or rating == '') then
		--APCData:Print("Bracket: ".. bracket .."  rating: no team")
		return ''
	end
	--APCData:Print("Bracket: ".. bracket .."  rating: ".. rating)
	local result = 0
	if rating <= 1500 then
		local multiplier = (178267/361593750000)*(rating*rating) - (10400203/7231875000)*rating + (3056434/2410625)
		result = (multiplier*rating) + 14
	else
		result = 1511.26/(1+(1639.28*2.71828^(-0.00412*rating)))
	end
	if bracket == "2v2" then
		result = result * 0.76
	elseif bracket == "3v3" then
		result = result * 0.88
	end
	return math.floor( result + 0.5)
end
